//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  C'0,70,0'
#property indicator_color2  C'70,0,0'
#property indicator_color3  Red
#property indicator_color4  Green
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int    Tenkan          = 9;
extern int    Kijun           = 26;
extern int    AdaptPeriod     = 15;
extern int    AdaptPrice      = PRICE_CLOSE;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";


//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double buffer3[];
double buffer4[];
double trend[];

//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
     IndicatorBuffers(5);
     SetIndexBuffer(0,buffer3);       SetIndexStyle(0,DRAW_HISTOGRAM);
     SetIndexBuffer(1,buffer4);       SetIndexStyle(1,DRAW_HISTOGRAM);
     SetIndexBuffer(2,Tenkan_Buffer); SetIndexLabel(2,"Tenkan Sen");
     SetIndexBuffer(3,Kijun_Buffer);  SetIndexLabel(3,"Kijun Sen");   
     SetIndexBuffer(4,trend);   
     
     IndicatorShortName("Tenkan Sen-Kijun Sen ribbon");
     
return(0);
}

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
       
       double thi    = High[i];
       double tlo    = Low[i];
       double tprice = 0;
       double dev    = iStdDev(NULL,0,AdaptPeriod,0,MODE_SMA,AdaptPrice,i);
       double avg    = iSma(dev,AdaptPeriod,i,0);
       double coeff  = 1; if (dev!=0) coeff = avg/dev;
       
       if (i >= Bars - Tenkan) continue;
       for(k = 0; k < Tenkan; k++)
       {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
       }
       
       if ((thi+tlo) > 0.0) 
            Tenkan_Buffer[i] = iSsm((thi + tlo)*0.5,coeff*Tenkan,i,0); 
       else Tenkan_Buffer[i] = iSsm(0,              coeff*Tenkan,i,0);
       
       //
       //
       //
       //
       //
       
       double khi    = High[i];
       double klo    = Low[i];
       double kprice = 0;
       if  (i >= Bars - Kijun) continue;
       for (k = 0; k < Kijun; k++)
       {
          kprice = High[i+k];
          if(khi < kprice)  khi  = kprice;
         
          kprice = Low[i+k];
          if(klo  > kprice) klo  = kprice;
       }
        
       if ((khi+klo) > 0.0) 
            Kijun_Buffer[i] = iSsm((khi + klo)*0.5,coeff*Kijun,i,1); 
       else Kijun_Buffer[i] = iSsm(0,              coeff*Kijun,i,1);
       buffer3[i] = Tenkan_Buffer[i];
       buffer4[i] = Kijun_Buffer[i];
       
       //
       //
       //
       //
       //
       
       trend[i] = trend[i+1];
       if (Tenkan_Buffer[i]>Kijun_Buffer[i]) trend[i] = 1;
       if (Tenkan_Buffer[i]<Kijun_Buffer[i]) trend[i] =-1;
            
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;  
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][4];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}

//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SS Tenkan Sen-Kijun Sen ribbon ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SS Tenkan Sen-Kijun Sen ribbon "),message);
             if (alertsSound)   PlaySound(soundFile);
      }

 } 
  